# hello_exit_arm.s

#  assemble with     "as -o hello_exit_arm.o hello_exit_arm.s"
#  link with         "ld -o hello_exit_arm hello_exit_arm.o"

# Run "./hello_exit_arm"
# then "echo $?"

# Syscalls
.equ SYSCALL_EXIT,     1


        .globl _start
_start:

	ldr	r1,=our_string		@ load pointer to hello string into r1
	mov	r2,#0			@ init count to zero
loop:
	ldrb	r0,[r1]			@ load byte pointed by r1 into r0
	cmp	r0,#' '			@ compare r0 to space char
					@ this updates the status flags
	beq	done			@ if it was equal, we are done
	add	r2,r2,#1		@ increment our count
	add	r1,r1,#1		@ increment our pointer

	b	loop			@ branch unconditionally to loop
done:

        #================================
        # Exit
        #================================
exit:
	mov	r0,r2			@ put result into r0
	mov	r7,#SYSCALL_EXIT	@ put exit syscall number (1) in r7
	swi	0x0			@ and exit


.data
our_string:	.ascii "Counting Hello world!\n\0"

